

// C Source File
// Created 8/23/2003; 10:21:03 AM


#define USE_TI89			  // Compile for TI-89
#define USE_TI92PLUS		  // Compile for TI-92 Plus
#define USE_V200			  // Compile for V200
//#define ENABLE_ERROR_RETURN   // Enable Returning Errors to AMS
#define OPTIMIZE_ROM_CALLS	  // Use ROM Call Optimization
//#define MIN_AMS 100 		  // Compile for AMS 1.00 or higher
#define SAVE_SCREEN 		  // Save/Restore LCD Contents
#include <tigcclib.h>		  // Include All Header Files
//#include "extgraph.h"
#define width (2*LCD_WIDTH)
#define height (2*LCD_HEIGHT)

/*
I didn't create the very efficient algorithm used in this program,I only
adapted it. (though I did made one (but it was slow and ugly(!)))


By the way, to understand the code better, you can
change all the bit shifter "<<1" and ">>1" with "/2" and "*2"
It doesn't matter, but the second method produce slightly larger code.
*/

void drawfrac(int x1, int y1, int n, int z, int a) {
    int i,ii,x2,y2;
    int size=0;
    x2=x1;
    y2=y1;
    size=pow(2,n)-1;
    int data[8]={1*z,0,0,-1*z,-1*z,0,0,1*z}; //the array that contains all the vectors.
    for(i = 0; i != size; i++) {
        if (i !=0) {
            ii=i;
            while (ii%2==0) {
                ii=ii>>1;
                }
            a+=(((((ii-1)>>1)%2)<<1)-1);//have fun understanding this one !
            }
        if (a == -1)
            a = 3;
        if (a == 4)
            a = 0;
        x1=x2;
        y1=y2;
        x2=x2+data[a<<1];
        y2=y2+data[(a<<1)+1];
        if (x1+x2 < width && x1+x2 > 0 && y1+y2 > 0 && y1+y2 <height)
        DrawLine(x1,y1,x2,y2,A_XOR);
        //Using ExtGraph is faster, but it makes the prgm 400 bytes larger!
        //FastDrawLine(LCD_MEM,x1,y1,x2,y2,A_XOR);
        }
    }

void _main(void)
    {
    ClrScr();
    FontSetSys(F_8x10);
    DrawStr (3,3,"Dragon Curve By Jfg",A_NORMAL);
    FontSetSys(F_6x8);
    DrawStr (2,18,"keys:",A_NORMAL);
    FontSetSys(F_4x6);
    DrawStr (6,30,"More detail : +",A_NORMAL);
    DrawStr (6,38,"Less detail : -",A_NORMAL);
    DrawStr (6,46,"Zoom in : *",A_NORMAL);
    DrawStr (6,54,"Zoom out : /",A_NORMAL);
    DrawStr (6,62,"Rotate right : )",A_NORMAL);
    DrawStr (6,70,"Rotate left : (",A_NORMAL);
    DrawStr (6,78,"Move the graph : the arrows",A_NORMAL);
    DrawStr (6,86,"Quit : Esc",A_NORMAL);
    ngetchx();
    int k=0,x=20,y=20,n=3,z=3,a=1;
    while (k !=264) {
        ClrScr();
        drawfrac(x,y,n,z,a);
        k = ngetchx();
        /*
        switch (k)
        {
        case 43:
        if (n<13) n++; break;
        case 45:
        if (n>1) n--; break;
        case 337:
        y--; break;
        case 340:
        y++; break;
        case 344:
        x++; break;
        case 338:
        x--; break;
        case 40:
        a++; break;
        case 41:
        a--; break;
        case 42:
        if (z!=12) z++; break;
        case 47:
        if (z!=2) z--; break;
        }
        */
        //Using "if"s produce a tighter code than with "case" !
        if (k == 43 && n<13)
            n++;
        if (k == 45 && n>1)
            n--;
        if (k == 337)
            y--;
        if (k == 340)
            y++;
        if (k == 344)
            x++;
        if (k == 338)
            x--;
        if (k == 40)
            a++;
        if (k == 41)
            a--;
        if (k == 42 && z!= 12)
            z++;
        if (k == 47 && z!= 2)
            z--;
        if (a == -1)
            a = 3;
        if (a == 4)
            a = 0;
        }
    }